{-# LANGUAGE OverloadedStrings #-}
module Ubc.Parse.Syntax.Enumeration 
( Enumeration(..)
, parse
)
where

import Text.Parsec (ParsecT, many, (<?>))

import qualified Ubc.Parse.Syntax.Language as UbcLanguage
import Ubc.Parse.Syntax (Token)
import Data.Text (Text)

type EnumerationMember = Token
data Enumeration = Enumeration 
                        { name :: Text
                        , members :: [EnumerationMember]
                        }
                        deriving (Show)

parse :: Monad m => ParsecT Token u m Enumeration
parse = do
        UbcLanguage.reserved "enum"
        identifier <- UbcLanguage.identifier <?> "enum identifier"
        values <- UbcLanguage.braces $ many UbcLanguage.identifier

        return $! Enumeration identifier values

